package cn.iocoder.yudao.module.pms.dal.mysql.iotdevicetemplateattrs;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.module.pms.controller.admin.iotdevicetemplateattrs.vo.IotDeviceTemplateAttrsPageReqVO;
import cn.iocoder.yudao.module.pms.dal.dataobject.iotdevicetemplateattrs.IotDeviceTemplateAttrsDO;
import org.apache.ibatis.annotations.Mapper;

/**
 * PMS 功能优化 设备模板属性 Mapper
 *
 * @author 芋道源码
 */
@Mapper
public interface IotDeviceTemplateAttrsMapper extends BaseMapperX<IotDeviceTemplateAttrsDO> {

    default PageResult<IotDeviceTemplateAttrsDO> selectPage(IotDeviceTemplateAttrsPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<IotDeviceTemplateAttrsDO>()
                .eqIfPresent(IotDeviceTemplateAttrsDO::getDeviceCategoryId, reqVO.getDeviceCategoryId())
                .eqIfPresent(IotDeviceTemplateAttrsDO::getDeviceId, reqVO.getDeviceId())
                .eqIfPresent(IotDeviceTemplateAttrsDO::getTemplateId, reqVO.getTemplateId())
                .likeIfPresent(IotDeviceTemplateAttrsDO::getName, reqVO.getName())
                .eqIfPresent(IotDeviceTemplateAttrsDO::getCode, reqVO.getCode())
                .eqIfPresent(IotDeviceTemplateAttrsDO::getType, reqVO.getType())
                .eqIfPresent(IotDeviceTemplateAttrsDO::getRequiredFlag, reqVO.getRequiredFlag())
                .eqIfPresent(IotDeviceTemplateAttrsDO::getDefaultValue, reqVO.getDefaultValue())
                .eqIfPresent(IotDeviceTemplateAttrsDO::getUnit, reqVO.getUnit())
                .eqIfPresent(IotDeviceTemplateAttrsDO::getDescription, reqVO.getDescription())
                .eqIfPresent(IotDeviceTemplateAttrsDO::getStatus, reqVO.getStatus())
                .eqIfPresent(IotDeviceTemplateAttrsDO::getRemark, reqVO.getRemark())
                .eqIfPresent(IotDeviceTemplateAttrsDO::getSort, reqVO.getSort())
                .eqIfPresent(IotDeviceTemplateAttrsDO::getSelectOptions, reqVO.getSelectOptions())
                .eqIfPresent(IotDeviceTemplateAttrsDO::getVersion, reqVO.getVersion())
                .betweenIfPresent(IotDeviceTemplateAttrsDO::getCreateTime, reqVO.getCreateTime())
                .orderByDesc(IotDeviceTemplateAttrsDO::getId));
    }

}